<template>
  <div>
    <div class="subtitle-2">
      <strong>Tags asociados</strong> <span class="tRojo">*</span>
    </div>
    <v-combobox
      v-model="selected"
      :filter="filter"
      :hide-no-data="!search"
      :items="items"
      @input="input"
      :search-input.sync="search"
      @update:search-input="update"
      :delimiters="[',']"
      :error="data.validator.$error"
      hide-selected
      multiple
      small-chips
      item-text="descripcion"
      item-value="idEtiqueta"
      persistent-hint
      :disabled="working"
      hint="Ejemplo: Mejora continua, Trabajo colaborativo o Consejos"
    >
      <template v-if="data.validator.$error" v-slot:append>
        <v-popover placement="bottom-end" color="red" offset="16">
          <v-icon class color="#fd5151">mdi-alert-circle</v-icon>
          <template slot="popover">
            <div @click="data.validator.$reset()" v-close-popover>
              <div v-if="!data.validator.required">
                ¡No te olvides de éste campo!
              </div>
            </div>
          </template>
        </v-popover>
      </template>
      <template v-slot:no-data>
        <v-list-item>
          <span class="subheading"
            >Preciona <v-icon x-small>mdi-keyboard-return</v-icon> para crear
          </span>
          <v-chip label small class="ml-1">
            {{ search }}
          </v-chip>
        </v-list-item>
      </template>
      <template v-slot:selection="{ attrs, item, parent, selected }">
        <v-chip
          v-if="item.idEtiqueta"
          v-bind="attrs"
          :input-value="selected"
          label
          small
          class="pr-0"
        >
          <span class="pr-2"> {{ item.descripcion }}</span>
          <v-btn elevation="1" icon x-small>
            <v-icon small @click="removeLocal(parent, item)">mdi-close</v-icon>
          </v-btn>
        </v-chip>
      </template>
      <template v-slot:item="{ index, item }">
        <v-text-field
          v-if="editing === item"
          v-model="editing.descripcion"
          autofocus
          flat
          background-color="transparent"
          hide-details
          solo
          @keyup.enter="edit(index, item)"
        ></v-text-field>
        <v-chip v-else dark label small>
          {{ item.descripcion }}
        </v-chip>
        <v-spacer></v-spacer>
        <v-list-item-action @click.stop>
          <v-btn icon @click.stop.prevent="edit(index, item)">
            <v-icon>{{ editing !== item ? "mdi-pencil" : "mdi-check" }}</v-icon>
          </v-btn>
        </v-list-item-action>
      </template>
    </v-combobox>
  </div>
</template>
<script>
import store from "@/store";
const axios = store.state.axiosApiLocal;
export default {
  name: "Component-FolioEtiquetas",
  props: ["value", "folio"],
  data: () => ({
    editing: null,
    editingIndex: -1,
    items: [{ header: "Elige una opción o agrega alguna nueva" }],
    search: null,
    selected: [],
    working: false,
    savingString: true,
    lastValue: [],
    backup: [],
  }),
  watch: {
    selected: function(val, prev) {
      this.lastValue = JSON.parse(JSON.stringify(val));
      this.data.value = this.selected;
      this.$emit("input", this.data);
    },
  },
  computed: {
    data: {
      get() {
        return this.value;
      },
      set(value) {
        this.$emit("input", value);
      },
    },
  },
  methods: {
    input(value) {
      this.backup = JSON.parse(JSON.stringify(this.lastValue));
      let lessValue = this.lastValue.length;
      let currentValue = value.length;
      let lastTag = value[value.length - 1];
      if (lessValue < currentValue) {
        if (lastTag) {
          if (typeof lastTag === "string") {
            lastTag = lastTag.trim();
            let tag = this.findChip(lastTag);
            if (!tag) {
              let newTag = {
                descripcion: lastTag,
              };
              this.postEtiqueta(newTag);
            } else {
              let chipTemp = this.selected.filter((term) => {
                return (
                  term.descripcion &&
                  term.descripcion.trim().toLowerCase() ===
                    lastTag.trim().toLowerCase()
                );
              });
              if (chipTemp.length === 0) {
                this.postEtiquetaFolio(tag, true);
              }
            }
            this.selected = this.selected.filter(
              (tag) => typeof tag !== "string"
            );
          } else {
            let tag = this.findChip(lastTag.descripcion);
            if (tag) {
              this.postEtiquetaFolio(lastTag, false);
            }
          }
        }
      } else {
        if (this.lastValue.length === 1) {
          lastTag = this.lastValue[0];
        } else {
          this.lastValue.forEach((itemPrev) => {
            let diff = value.filter(
              (itemVal) => itemVal.idEtiqueta === itemPrev.idEtiqueta
            );
            if (diff.length === 0) {
              lastTag = itemPrev;
            }
          });
        }
        if (lastTag) {
          this.deleteFolioEtiqueta(lastTag);
        }
      }
    },
    update(value) {
      if (value && value.split(",").length > 1) {
        value.split(",").forEach((term) => {
          if (term.length > 0) {
            this.selected.push(term);
            this.input(this.selected);
          }
        });
        this.search = "";
      }
    },
    findChip(str) {
      let chipTemp = this.items.filter((term) => {
        return (
          term.descripcion &&
          term.descripcion.trim().toLowerCase() === str.trim().toLowerCase()
        );
      });
      if (chipTemp.length > 0) {
        return chipTemp[0];
      } else {
        return null;
      }
    },
    removeLocal(parent, item) {
      parent.selectItem(item);
    },
    uuidv4() {
      return "xxxxxxxx".replace(/[xy]/g, function(c) {
        var r = (Math.random() * 16) | 0,
          v = c == "x" ? r : (r & 0x3) | 0x8;
        return v.toString(16);
      });
    },
    getFolioEtiquetas() {
      const self = this;
      axios(
        "/modelo-negocio/folio-etiquetas/v1/" +
          this.folio.idFolio +
          "/etiquetas"
      )
        .then((response) => {
          let data = response.data;
          if (data) {
            data.resultado.folioEtiquetas.map((item) => {
              let etiqueta = self.items.filter(
                (itemEtiqueta) => itemEtiqueta.idEtiqueta == item.idEtiqueta
              )[0];
              self.data.value.push(etiqueta);
            });
          }
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        });
    },
    postEtiquetaFolio(tag, push) {
      let body = {
        idEtiqueta: tag.idEtiqueta,
      };
      this.working = true;
      axios
        .post(
          "/modelo-negocio/folio-etiquetas/v1/" +
            this.folio.idFolio +
            "/etiquetas",
          body
        )
        .then((response) => {
          let data = response.data;
          if (data) {
            if (push) {
              this.selected.push(tag);
            }
          }
        })
        .catch((error) => {
          this.selected = JSON.parse(JSON.stringify(this.backup));
          console.log(error);
        })
        .finally(() => {
          this.working = false;
        });
    },
    deleteFolioEtiqueta(item) {
      axios
        .delete(
          "/modelo-negocio/folio-etiquetas/v1/" +
            this.folio.idFolio +
            "/etiquetas/" +
            item.idEtiqueta
        )
        .catch((error) => {
          this.selected = JSON.parse(JSON.stringify(this.backup));
          if (error.response) {
            console.log(error.response.data);
          }
        });
    },
    postEtiqueta(newTag) {
      this.working = true;
      axios
        .post("/modelo-negocio/catalogos/etiquetas/v1/", newTag)
        .then((response) => {
          let data = response.data;
          if (data) {
            newTag.idEtiqueta = data.resultado.id;
            this.items.push(newTag);
            this.postEtiquetaFolio(newTag, true);
          }
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        })
        .finally(() => {
          this.working = false;
        });
    },
    putEtiqueta(idEtiqueta, body) {
      axios
        .put("/modelo-negocio/catalogos/etiquetas/v1/" + idEtiqueta, body)
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        });
    },
    getEtiquetas() {
      const self = this;
      axios("/modelo-negocio/catalogos/etiquetas/v1/")
        .then((response) => {
          let data = response.data;
          if (data) {
            data.resultado.etiquetas.map((item) => {
              self.items.push(item);
            });
            self.getFolioEtiquetas();
          }
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        })
        .finally(() => {
          this.$emit("loaded", true);
        });
    },
    edit(index, item) {
      if (!this.editing) {
        this.editing = item;
        this.editingIndex = index;
      } else {
        this.editing = null;
        this.editingIndex = -1;
        let body = {
          descripcion: item.descripcion,
        };
        this.putEtiqueta(item.idEtiqueta, body);
      }
    },
    filter(item, queryText, itemText) {
      if (item.header) return false;
      const hasValue = (val) => (val != null ? val : "");
      const descripcion = hasValue(itemText);
      const query = hasValue(queryText);
      return (
        descripcion
          .toString()
          .toLowerCase()
          .indexOf(query.toString().toLowerCase()) > -1
      );
    },
  },
  created() {
    this.getEtiquetas();
    this.selected = this.value.value;
  },
};
</script>
